

public class test {
  public static void main(String[] args) {
    P4.initEnv(args) ;
    P4.createProcGroup() ;

    int myId   = P4.getMyId() ;
    int nprocs = P4.numTotalIds() ;

    int [] buf = new int [1] ;
    SendBuffer outgoing = new SendBuffer(buf) ;
    RecvBuffer incoming = new RecvBuffer(buf) ;

    for(int i = 0 ; i < 10 ; i++) {

      /* Forward */

      if(myId == 0)
	buf [0] = 23 + i ;
      else {
	P4.recv(0, myId - 1, incoming) ;
      }

      if(myId == nprocs - 1)
	System.out.println("Process " + myId + " received = " + buf [0]) ;
      else
	P4.send(0, myId + 1, outgoing) ;

      /* Backward */

      if(myId != nprocs - 1)
	P4.recv(0, myId + 1, incoming) ;

      if(myId == 0)
	System.out.println("Process " + myId + " received = " + buf [0]) ;
      else {
	P4.send(0, myId - 1, outgoing) ;
      }
    }

    P4.waitForEnd() ;
  }
}

//public class test {
//  public static void main(String[] args) {
//    P4.initEnv(args) ;
//    P4.createProcGroup() ;
//
//    int myId   = P4.getMyId() ;
//
//    System.out.println("Hello from process " + myId) ;
//
//    int [] buf = new int [1] ;
//
//    if(myId == 0) {
//      RecvBuffer incoming = new RecvBuffer(buf) ;
//      P4.recv(0, 1, incoming) ;
//      System.out.println("Process " + myId + " received = " + buf [0]) ;
//    } 
//    if(myId == 1) {
//      buf [0] = 23 ;
//      SendBuffer outgoing = new SendBuffer(buf) ;
//      P4.send(0, 0, outgoing) ;
//    }
//
//    P4.waitForEnd() ;
//  }
//}

